<!DOCTYPE html>
<html lang="ru">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task with await</title>
  </head>
  <body>
    <button type="button" id="getResultBtn">Get phrase</button>
    <div id="result"></div>

    <script>
      const baseUrl = "https://fe.it-academy.by/Examples/words_tree/";
      const initialFileName = "root.txt";

      const fetchFile = async (fileName) => {
        try {
          const response = await fetch(`${baseUrl}${fileName}`);

          let fileContent;
          const responseClone = await response.clone();
          try {
            fileContent = await response.json();
          } catch {
            fileContent = await responseClone.text();
          }

          if (Array.isArray(fileContent)) {
            const partsOfText = await Promise.all(fileContent.map(fetchFile));
            return partsOfText.join(" ");
          } else {
            return fileContent;
          }
        } catch (err) {
          console.warn(err);
          return null;
        }
      }

      const handleClick = async () => {
        const resultText = await fetchFile(initialFileName);

        const div = document.getElementById("result");
        div.innerText = resultText;
      }

      const btn = document.getElementById("getResultBtn");
      btn.addEventListener("click", handleClick);
    </script>
  </body>
</html>
